#version 430 core

layout(location = 0) in vec3 vertexPosition;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal;

out vec3 fragPosition;
out vec2 fragUV;
out vec3 fragNormal;
out vec3 worldPosition;
out vec3 worldNormal;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;


void main() {
	gl_Position = (projectionMatrix * viewMatrix * modelMatrix) * vec4(vertexPosition, 1);

	fragPosition = vertexPosition;
	fragUV = vertexUV;
	fragNormal = vertexNormal;
	worldPosition = vec3(modelMatrix * vec4(vertexPosition, 1));
	worldNormal = vec3(modelMatrix * vec4(vertexNormal, 0));
}