#version 330 core


in vec2 UV;

out vec4 color;

uniform sampler2D renderedTexture;
uniform vec2 window;
uniform float sampleRate;
 
const float gamma_in = 2.2;
const float gamma_out = 4.0;


void main(void)
{

  float samples = sampleRate; 


  vec4 source = texture(renderedTexture, UV);
  vec4 sum = vec4(0);
  vec2 sizeFactor = 1 / window;
  float samples_x = (samples - 1) * sizeFactor.x;
  float samples_y = (samples - 1) * sizeFactor.y;
  
  for (float x = -(samples_x * sizeFactor.x); x <= samples_x * sizeFactor.x; x = x + sizeFactor.x)
  {
    for (float y = -(samples_y * sizeFactor.y); y <= samples_y * sizeFactor.y; y = y + sizeFactor.y)
    {
      sum += texture(renderedTexture, vec2(UV.x + x, UV.y + y));
    }
  }
  
  //color = sum * vec4(0.3f,0.5f,0.7f,1.0f);
  color = sum * vec4(0.1,0,1,1);


  //color = vec4(color_glow, 1);

}